CdsRestClient::CdsRestConnection Class Reference

class for Microsoft Common Data Service REST connections; returns CdsRestClient objects More...

Inheritance diagram for CdsRestClient::CdsRestConnection:
[legend]

## Public Member Functions

| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the CdsRestConnection object More...
DataProvider::AbstractDataProvider | getDataProvider ()
| returns a data provider object for this connection More...
string | getType ()
| returns `"cdsrest"`
bool | hasDataProvider ()
| returns True as this connection returns a data provider with the getDataProvider() method More...

## Public Attributes

const | ConnectionScheme = ...
| Connection entry info.

## Protected Member Functions

hash< ConnectionSchemeInfo > | getConnectionSchemeInfoImpl ()
| Returns the ConnectionSchemeInfo hash for this object.
CdsRestClient | getImpl (bool connect=True, *hash< auto > rtopts)
| returns a CdsRestClient object More...

## Detailed Description

class for Microsoft Common Data Service REST connections; returns CdsRestClient objects

supports the following options:

- `"api"`: the API version for CDS
- `"client_id"`: (required) the Microsoft Common Data Service OAuth2 client ID
- `"client_secret"`: (required) the Microsoft Common Data Service OAuth2 client secret
- `"connect_timeout"`: connection timeout to use in milliseconds
- `"content_encoding"`: this sets the send encoding (if the `"send_encoding"` option is not set) and the requested response encoding; for possible values, see EncodingSupport
- `"data"`: see DataSerializationOptions for possible values; the default is `"json"`
- `"error_passthru"`: if True then HTTP status codes indicating errors will not cause a `REST-RESPONSE-ERROR` exception to be raised, rather such responses will be passed through to the caller like any other response
- `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
- `"max_redirects"`: maximum redirects to support
- `"proxy"`: proxy URL to use
- `"redirect_passthru"`: if True then redirect responses will be passed to the caller instead of processed
- `"send_encoding"`: a send data encoding option or the value `"auto"` which means to use automatic encoding; if not present defaults to no content-encoding on sent message bodies
- `"scope"`: the OAuth2 scope for the login; the default it to use the target URL + "/.default"
- `"tenant"`: (required) the tenant ID
- `"timeout"`: transfer timeout to use in milliseconds

See also
  CdsRestClient::constructor() for more information on the above options

## Member Function Documentation

## constructor()

CdsRestClient::CdsRestConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = `{}`,
|  | hash< auto > | options = `{}`
| ) |  |

creates the CdsRestConnection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See ConnectionProvider::AbstractConnection::constructor() for `attributes` and `options` reference.

Exceptions

  CONNECTION-OPTION-ERROR | missing or invalid connection option

## getDataProvider()

DataProvider::AbstractDataProvider CdsRestClient::CdsRestConnection::getDataProvider | ( |  | ) |

returns a data provider object for this connection

Returns
  a data provider object for this connection

## getImpl()

CdsRestClient CdsRestClient::CdsRestConnection::getImpl | ( | bool | connect = `True`,
|  | *hash< auto > | rtopts
| ) |  |

protected

returns a CdsRestClient object

Parameters

  connect | if True, then the connection is returned already connected
  rtopts | this connection type does not accept any runtime options, so this parameter is ignored

Returns
  a CdsRestClient object

## hasDataProvider()

bool CdsRestClient::CdsRestConnection::hasDataProvider | ( |  | ) |

returns True as this connection returns a data provider with the getDataProvider() method

Returns
  True as this connection returns a data provider with the getDataProvider() method

See also
  getDataProvider()